"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFilterDateRange = void 0;

var _esQuery = require("@kbn/es-query");

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var createFilterDateRange = function createFilterDateRange(agg, _ref) {
  var from = _ref.from,
      to = _ref.to;
  var filter = {};
  if (from) filter.gte = (0, _moment.default)(from).toISOString();
  if (to) filter.lt = (0, _moment.default)(to).toISOString();
  if (to && from) filter.format = 'strict_date_optional_time';
  return (0, _esQuery.buildRangeFilter)(agg.params.field, filter, agg.getIndexPattern());
};

exports.createFilterDateRange = createFilterDateRange;